name: PYTHON - GIL, Threads, Asyncio
author: Libor Jonát
email: libor@quantlane.com
time: 2x45m
colors:
  - 1abc9c
notes:
  - I would like it interactive
  - Today we will talk about CPython
  - What is benefit of Python
  - What is bad about Python
about:

  - title: About me / Quantlane
    content:
      - I work as software engineer in Quantlane
      - Writing stock trading application which is almost whole in Python
      - Using Python almost everywhere

  - title: Big Buck Bunny
    content:
      - This repository contains the Big Buck Bunny https://peach.blender.org/about/ movie converted to ASCII art frames.
      - https://github.com/hit9/img2txt was used to convert each video frame to ASCII art.

  - title: Talk goals
    content:
      - 'https://gitlab.com/libor.jonat/ds-advanced-python'
      - What is GIL in CPython
      - Threads usability in CPython
      - Basic knowledge of Asyncio
      - Understanding what are generators good for

slides:

  - title: Global interpreter lock (GIL)
    image: https://callhub.io/wp-content/uploads/2016/06/python-gil-visualization.png
    content:
      - 'Source: https://callhub.io/understanding-python-gil/'
    notes:
      - IO bound thread can wait in parallel
      - Only one CPU bound thread can run
      - Why it is a problem?

  - title: 'Example: Threads'
    content:
      - Simple HTTP server writen in Python
      - Showcase why GIL is a problem
      - Not recomendet way to write web server
      - Also for files you should use nginx or different server
    notes:
      - Thread cancelation

  - title: Asyncio Basics and generators

  - title: Rewrite server using asyncio
    content:
      - aiohttp, sessions, handling etc...
      - Mesurable performance boost
      - Why?
      - Still not perfect - file descriptors


  - title: 'Example: Asyncio web player'
    notes:
      - queue used for buffering frames
      - max size used to limit memory
      - not perfect to use http